import { Web3 } from './web3wrapper';
import { ITesseractWeb3ProviderFactory } from './types';
import { Ethereum } from '@tesseractjs/ethereum/esm';
import { HttpProviderOptions, WebsocketProviderOptions, Network } from './types';
import { Web3FallbackProvider, Web3NativeProvider, Web3OpenWalletProvider } from './providers';
export declare type Web3RpcUrlInfo = string | {
    url: string;
    options?: HttpProviderOptions | WebsocketProviderOptions;
};
interface Web3Constructor {
    rpcUrls: {
        [key: number]: Web3RpcUrlInfo;
    };
    providers: Array<ITesseractWeb3ProviderFactory>;
    (rpcUrl: string, rpcOptions?: HttpProviderOptions | WebsocketProviderOptions): Promise<Web3>;
    (netId: Network | number): Promise<Web3>;
}
declare module '@tesseractjs/ethereum/esm' {
    interface Ethereum {
        Web3: Web3Constructor;
    }
}
export { Web3, Web3FallbackProvider, Web3NativeProvider, Web3OpenWalletProvider, Ethereum, Network };
export { Tesseract } from '@tesseractjs/core/esm';
