export class Web3FallbackProvider {
    has(target, p) {
        switch (p) {
            case 'hasClientWallet': return true;
            // case 'supportsSubscriptions': return true
            default: return Reflect.has(target, p);
        }
    }
    get(target, p, receiver) {
        switch (p) {
            case 'hasClientWallet': return false;
            // case 'supportsSubscriptions': return Reflect.get(target, 'on', receiver) !== undefined
            default: return Reflect.get(target, p, receiver);
        }
    }
    set(target, p, value, receiver) {
        switch (p) {
            case 'hasClientWallet': return false;
            // case 'supportsSubscriptions': return false
            default: return Reflect.set(target, p, value, receiver);
        }
    }
    ownKeys(target) {
        return Reflect.ownKeys(target).concat(['hasClientWallet', 'supportsSubscriptions']);
    }
    static async create({ provider }) {
        if (!provider) {
            throw new Error('provider is undefined');
        }
        return new Proxy(provider, new Web3FallbackProvider());
    }
}
