export class Web3ProviderProxy {
    has(target, p) {
        switch (p) {
            case 'on': return target.supportsSubscriptions();
            default: return Reflect.has(target, p);
        }
    }
    get(target, p, receiver) {
        switch (p) {
            case 'on': return target.supportsSubscriptions() ? Reflect.get(target, p, receiver) : undefined;
            default: return Reflect.get(target, p, receiver);
        }
    }
    ownKeys(target) {
        if (!target.supportsSubscriptions()) {
            const keys = Reflect.ownKeys(target);
            keys.splice(keys.indexOf('on'), 1);
            return keys;
        }
        return Reflect.ownKeys(target);
    }
}
