"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var web3wrapper_1 = require("./web3wrapper");
exports.Web3 = web3wrapper_1.Web3;
var ethereum_1 = require("@tesseractjs/ethereum");
exports.Ethereum = ethereum_1.Ethereum;
var types_1 = require("./types");
exports.Network = types_1.Network;
var providers_1 = require("./providers");
exports.Web3FallbackProvider = providers_1.Web3FallbackProvider;
exports.Web3NativeProvider = providers_1.Web3NativeProvider;
exports.Web3OpenWalletProvider = providers_1.Web3OpenWalletProvider;
ethereum_1.Ethereum.addPlugin("Web3", function (ethereum) {
    function web3Constructor(rpcUrlOrNetId, rpcOptions) {
        var netId;
        var rpcUrl;
        if (typeof rpcUrlOrNetId === 'string') {
            rpcUrl = rpcUrlOrNetId;
        }
        else {
            netId = rpcUrlOrNetId;
            var rpcInfo = ethereum.Web3.rpcUrls[netId];
            if (rpcInfo) {
                if (typeof rpcInfo === 'string') {
                    rpcUrl = rpcInfo;
                }
                else {
                    rpcUrl = rpcInfo.url;
                    rpcOptions = rpcOptions || rpcInfo.options;
                }
            }
        }
        return web3wrapper_1.Web3.create(ethereum.Web3.providers, ethereum.openWallet, netId, rpcUrl, rpcOptions);
    }
    web3Constructor.rpcUrls = {};
    web3Constructor.providers = [providers_1.Web3NativeProvider, providers_1.Web3OpenWalletProvider, providers_1.Web3FallbackProvider];
    return web3Constructor;
});
var core_1 = require("@tesseractjs/core");
exports.Tesseract = core_1.Tesseract;
