"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var rpc_1 = require("../../rpc");
var libs_1 = require("../../libs");
function buildSignedTransaction(tx, signature, chainId) {
    tx.data = tx.data || '0x';
    var rlpData = libs_1.eth.transaction.signingData(tx);
    var rawTransaction = libs_1.eth.RLP.decode(rlpData)
        .slice(0, 6)
        .concat(libs_1.eth.account.decodeSignature(signature));
    var fixedV = libs_1.Web3.utils.toBN(rawTransaction[6]).add(chainId.muln(2).addn(8));
    rawTransaction[6] = libs_1.eth.bytes.fromNat(libs_1.Web3.utils.toHex(fixedV));
    return libs_1.eth.RLP.encode(rawTransaction);
}
exports.HANDLERS = {};
exports.HANDLERS['eth_accounts'] = exports.HANDLERS['eth_requestAccounts'] = exports.HANDLERS['eth_coinbase'] =
    function (eth, request, netId) {
        switch (request.method) {
            case 'eth_accounts': return eth.accounts(netId);
            case 'eth_requestAccounts': return eth.accounts(netId);
            case 'eth_coinbase': return eth.accounts(netId).then(function (accounts) { return accounts[0]; });
            default: return Promise.reject('Wrong method: ' + request.method);
        }
    };
exports.HANDLERS['eth_signTypedData'] = exports.HANDLERS['eth_signTypedData_v3'] =
    exports.HANDLERS['personal_signTypedData'] = exports.HANDLERS['personal_signTypedData_v3'] =
        function (eth, request, netId) {
            return eth.signTypedData(request.params[0], request.params[1], netId)
                .then(function (data) { return libs_1.Web3.utils.asciiToHex(atob(data)); });
        };
exports.HANDLERS['personal_sign'] = function (eth, request, netId) {
    return eth.signData(request.params[1], request.params[0], netId)
        .then(function (data) { return libs_1.Web3.utils.asciiToHex(atob(data)); });
};
exports.HANDLERS['eth_sign'] = function (eth, request, netId) {
    return eth.signData(request.params[0], request.params[1], netId)
        .then(function (data) { return libs_1.Web3.utils.asciiToHex(atob(data)); });
};
exports.HANDLERS['eth_sendTransaction'] = function (eth, request, netId, chainId, provider) {
    return __awaiter(this, void 0, void 0, function () {
        var tx, _a, _b, _c, _d, _e, _f, _g, oldData, signature, _h, _j, _k, sendRawReq, response;
        return __generator(this, function (_l) {
            switch (_l.label) {
                case 0:
                    tx = request.params[0];
                    if (!!tx.nonce) return [3 /*break*/, 2];
                    _a = tx;
                    return [4 /*yield*/, rpc_1.getTransactionCount(provider, tx.from)];
                case 1:
                    _a.nonce = _l.sent();
                    _l.label = 2;
                case 2:
                    if (!!tx.gasPrice) return [3 /*break*/, 4];
                    _b = tx;
                    _d = (_c = libs_1.Web3.utils).toHex;
                    return [4 /*yield*/, rpc_1.getGasPrice(provider)];
                case 3:
                    _b.gasPrice = _d.apply(_c, [_l.sent()]);
                    _l.label = 4;
                case 4:
                    if (!!tx.gas) return [3 /*break*/, 6];
                    _e = tx;
                    _g = (_f = libs_1.Web3.utils).toHex;
                    return [4 /*yield*/, rpc_1.estimateGas(provider, tx)];
                case 5:
                    _e.gas = _g.apply(_f, [(_l.sent()).muln(1.3)]);
                    _l.label = 6;
                case 6:
                    oldData = tx.data;
                    tx.data = tx.data ? btoa(String.fromCharCode.apply(String, libs_1.Web3.utils.hexToBytes(tx.data))) : '';
                    _j = (_h = libs_1.Web3.utils).asciiToHex;
                    _k = atob;
                    return [4 /*yield*/, eth.signTx(tx, netId, chainId)];
                case 7:
                    signature = _j.apply(_h, [_k.apply(void 0, [_l.sent()])]);
                    tx.data = oldData;
                    sendRawReq = libs_1.Jsonrpc.toPayload('eth_sendRawTransaction', [buildSignedTransaction(tx, signature, libs_1.Web3.utils.toBN(chainId))]);
                    return [4 /*yield*/, rpc_1.promisifiedSend(provider, sendRawReq)];
                case 8:
                    response = _l.sent();
                    if (response.error)
                        throw response.error;
                    return [2 /*return*/, response.result];
            }
        });
    });
};
