import { ITesseractWeb3Provider, TesseractWeb3ProviderOptions, AnyWeb3Provider } from '../../types';
import { Ethereum } from '@tesseractjs/openwallet-ethereum';
import { JsonRpcPayload, JsonRpcResponse } from 'web3-core-helpers';
export declare class Web3OpenWalletProvider implements ITesseractWeb3Provider {
    hasClientWallet: boolean;
    private ethereum;
    private provider;
    private netId;
    private chainId;
    get connected(): boolean;
    supportsSubscriptions(): boolean;
    constructor(netId: number, ethereum: Ethereum, provider: AnyWeb3Provider);
    send(payload: JsonRpcPayload, callback: (error: Error | null, result?: JsonRpcResponse) => void): void;
    on(type: string, callback: (message?: any) => any): void;
    removeListener(type: string, callback: (message?: any) => any): void;
    reset(): void;
    private static createNative;
    static create({ openWallet, provider, netId }: TesseractWeb3ProviderOptions): Promise<ITesseractWeb3Provider>;
}
