"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var openwallet_ethereum_1 = require("@tesseractjs/openwallet-ethereum");
var rpc_1 = require("../../rpc");
var node_1 = require("./node");
var handlers_1 = require("./handlers");
var Web3OpenWalletProvider = /** @class */ (function () {
    function Web3OpenWalletProvider(netId, ethereum, provider) {
        this.hasClientWallet = true;
        this.netId = netId;
        this.chainId = rpc_1.getChainId(provider);
        this.provider = provider;
        this.ethereum = ethereum;
    }
    Object.defineProperty(Web3OpenWalletProvider.prototype, "connected", {
        get: function () {
            return this.provider.connected;
        },
        enumerable: true,
        configurable: true
    });
    Web3OpenWalletProvider.prototype.supportsSubscriptions = function () {
        return this.provider.supportsSubscriptions();
    };
    Web3OpenWalletProvider.prototype.send = function (payload, callback) {
        var _this = this;
        this.chainId
            .then(function (chainId) {
            var handler = handlers_1.HANDLERS[payload.method];
            if (handler) {
                return handler(_this.ethereum, payload, _this.netId, chainId, _this.provider)
                    .then(function (result) { return ({ jsonrpc: payload.jsonrpc, id: payload.id, result: result }); });
            }
            return rpc_1.promisifiedSend(_this.provider, payload);
        })
            .then(function (response) {
            if (response.error)
                throw response.error;
            callback(null, response);
        })
            .catch(function (err) { return callback(err); });
    };
    Web3OpenWalletProvider.prototype.on = function (type, callback) {
        if (!this.supportsSubscriptions()) {
            throw new Error('Subscriptions is not supported');
        }
        this.provider.on(type, callback);
    };
    Web3OpenWalletProvider.prototype.removeListener = function (type, callback) {
        if (!this.supportsSubscriptions()) {
            throw new Error('Subscriptions is not supported');
        }
        this.provider.removeListener(type, callback);
    };
    Web3OpenWalletProvider.prototype.reset = function () {
        if (typeof this.provider.reset === 'function') {
            this.provider.reset();
        }
    };
    Web3OpenWalletProvider.createNative = function (ethereum, netId) {
        return __awaiter(this, void 0, void 0, function () {
            var provider;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, node_1.OpenWalletNodeProvider.create(ethereum, netId)];
                    case 1:
                        provider = _a.sent();
                        return [2 /*return*/, new Web3OpenWalletProvider(netId, ethereum, provider)];
                }
            });
        });
    };
    Web3OpenWalletProvider.create = function (_a) {
        var openWallet = _a.openWallet, provider = _a.provider, netId = _a.netId;
        return __awaiter(this, void 0, void 0, function () {
            var ethereum, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        ethereum = new openwallet_ethereum_1.Ethereum(openWallet);
                        if (!openWallet.hasOpenWallet) {
                            throw new Error('OpenWallet is not supported');
                        }
                        return [4 /*yield*/, ethereum.isKeychainInstalled()];
                    case 1:
                        if (!(_c.sent())) {
                            throw new Error('OpenWallet does not support Ethereum keychain');
                        }
                        _c.label = 2;
                    case 2:
                        _c.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, this.createNative(ethereum, netId)];
                    case 3: return [2 /*return*/, _c.sent()];
                    case 4:
                        _b = _c.sent();
                        if (!provider) {
                            throw new Error('Doesn\'t have any provider');
                        }
                        return [2 /*return*/, new Web3OpenWalletProvider(netId, ethereum, provider)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    return Web3OpenWalletProvider;
}());
exports.Web3OpenWalletProvider = Web3OpenWalletProvider;
