import { Ethereum } from '@tesseractjs/openwallet-ethereum';
import { JsonRpcPayload, JsonRpcResponse } from 'web3-core-helpers';
import { IWeb3Provider } from '../../types';
export declare class OpenWalletNodeProvider implements IWeb3Provider {
    private ethereum;
    private netId;
    private subscriptions;
    private subscribers;
    private _supportsSubscriptions;
    connected: boolean;
    supportsSubscriptions(): boolean;
    constructor(ethereum: Ethereum, netId: number, supportsSubscriptions: boolean);
    private emit;
    send(payload: JsonRpcPayload, callback: (error: Error | null, result?: JsonRpcResponse) => void): void;
    on(type: string, callback: (message?: any) => void): void;
    removeListener(type: string, callback: (message?: any) => any): void;
    reset(): void;
    static create(ethereum: Ethereum, netId: number): Promise<OpenWalletNodeProvider>;
}
