"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var rpc_1 = require("../rpc");
var Web3NativeProvider = /** @class */ (function () {
    function Web3NativeProvider() {
    }
    Web3NativeProvider.prototype.has = function (target, p) {
        switch (p) {
            case 'hasClientWallet': return true;
            case 'supportsSubscriptions': return true;
            default: return Reflect.has(target, p);
        }
    };
    Web3NativeProvider.prototype.get = function (target, p, receiver) {
        switch (p) {
            case 'hasClientWallet': return true;
            case 'supportsSubscriptions': {
                var func = Reflect.get(target, p, receiver);
                if (typeof func === 'function') {
                    return func;
                }
                return function () { return Reflect.get(target, 'on', receiver) !== undefined; };
            }
            default: return Reflect.get(target, p, receiver);
        }
    };
    Web3NativeProvider.prototype.set = function (target, p, value, receiver) {
        switch (p) {
            case 'hasClientWallet': return false;
            case 'supportsSubscriptions': return false;
            default: return Reflect.set(target, p, value, receiver);
        }
    };
    Web3NativeProvider.prototype.ownKeys = function (target) {
        return Reflect.ownKeys(target).concat(['hasClientWallet', 'supportsSubscriptions']);
    };
    Web3NativeProvider._fromProvider = function (provider, netId) {
        return __awaiter(this, void 0, void 0, function () {
            var rpcNetId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, rpc_1.getNetId(provider)];
                    case 1:
                        rpcNetId = _a.sent();
                        if (netId !== rpcNetId) {
                            throw new Error('Provider has different netId');
                        }
                        return [2 /*return*/, new Proxy(provider, new Web3NativeProvider())];
                }
            });
        });
    };
    Web3NativeProvider.create = function (_a) {
        var netId = _a.netId;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!window) {
                            throw new Error('Will work only in browser');
                        }
                        if (!window.ethereum) return [3 /*break*/, 3];
                        return [4 /*yield*/, window.ethereum.enable()];
                    case 1:
                        _b.sent();
                        return [4 /*yield*/, this._fromProvider(window.ethereum, netId)];
                    case 2: return [2 /*return*/, _b.sent()];
                    case 3:
                        if (!(window.web3 && window.web3.currentProvider)) return [3 /*break*/, 5];
                        return [4 /*yield*/, this._fromProvider(window.web3.currentProvider, netId)];
                    case 4: return [2 /*return*/, _b.sent()];
                    case 5: throw new Error("Can't create provider");
                }
            });
        });
    };
    return Web3NativeProvider;
}());
exports.Web3NativeProvider = Web3NativeProvider;
