/// <reference types="bn.js" />
import { AnyWeb3Provider } from './types';
import { JsonRpcPayload, JsonRpcResponse } from 'web3-core-helpers';
import { Transaction } from '@tesseractjs/openwallet-ethereum';
import { BN } from './libs';
export declare function promisifiedSend(provider: AnyWeb3Provider, request: JsonRpcPayload): Promise<JsonRpcResponse>;
export declare function getNetId(provider: AnyWeb3Provider): Promise<number>;
export declare function getChainId(provider: AnyWeb3Provider): Promise<string>;
export declare function estimateGas(provider: AnyWeb3Provider, tx: Transaction): Promise<BN>;
export declare function getGasPrice(provider: AnyWeb3Provider): Promise<BN>;
export declare function getTransactionCount(provider: AnyWeb3Provider, address: string): Promise<string>;
